#include "AppUtils.h"
#include <QDesktopServices>
#include <QUrl>
#include <QProcess>
#include <QFile>
#include "utils/deviceutils.h"

void AppUtils::openUrlByDefaultBrower(const QString& url){
    QString urlStr = url;
    if(!urlStr.toLower().startsWith("http") && DeviceUtils::getPlatform() == DeviceUtils::MAC){
        urlStr = "file://" + url;
    }
    QDesktopServices::openUrl(QUrl(urlStr));
}

void AppUtils::openDirDialog(const string& path){
    QDesktopServices::openUrl(QUrl::fromLocalFile(QString(path.c_str())));
}

void AppUtils::openUrlByDefaultBrower(const string& url){
     openUrlByDefaultBrower(QString(url.c_str()));
}

void AppUtils::createShortcut(){
    QProcess process;
    if(DeviceUtils::getPlatform() == DeviceUtils::LINUX){
        QString location = QStandardPaths::writableLocation(QStandardPaths::DesktopLocation);
        if(!location.isEmpty()){
            QFile file(location+"/kiscloud.desktop");
            if(!file.exists()){
                QString path = "/opt/kingdeekiscloud/kiscloud.desktop";
                QFile file(path);
                if(file.exists()){
                    process.execute("cp " +path+ " "+location);
                }
            }
        }
     }

}



