#ifndef ACCOUNTSELECTWINDOW_H
#define ACCOUNTSELECTWINDOW_H
#include <QWidget>
#include "widgets/imageview.h"
#include "widgets/PopupWindow.h"
#include "widgets/expandlistpop.h"
#include "widgets/toastwidget.h"
#include "rdp/remotedesktopmanager.h"
#include "widgets/alertdialog.h"
#include "manager/rdpmanager.h"

class QMLineEdit;
class MainWindow;
class ProgressDialog;
class EnterpriseAccInfo;
class AdjustLengthPushButton;
class AccountData;
class AccountSelectWindow  :public QWidget,ImageClickListener{
private:
    int _windowBlurRadius;
    ToastWidget* _toast;
    std::unique_ptr<RdpManager> mRdpManagerPtr;
    ProgressDialog* _progdialog;
    QLabel* _loginType = nullptr;
    AdjustLengthPushButton* mAccLabel;
    AdjustLengthPushButton* mEnterpriseLabel;
    bool mConnectSuc =false;
//    QMLineEdit* _accountEdit;
    QFont _labelFont;
    QWidget* mCoverContainer;
    AlertDialog* mAlertDialog = nullptr;
    QColor _labelColor = QColor(100,100,100);
    QColor _borderColor = QColor(238,238,238);
    QWidget * _enterpriseLine;
    QWidget * _accountLine;
    int _lrpadding = 40;
    int mSelectedEnterpriseIndex = 0;
    int _rdpCode = -1;
    int mSelectedAccIndex = 0;
    QWidget * _container;
//    ImageView * mCountryCode;
    MainWindow* mHost;
    QString uid;
    QString mAcc;
    QString mPaw;
    QString token;
    QSize mCoverSize;
//    PubCloudConnectedAccount mConntAcount;
    vector<EnterpriseAccInfo*> mEnterpriseInfo;
//    void getAccList(QString& uid,QString& acToken,QString& token);
public:
    void setMainWindow(MainWindow* host);
    ~AccountSelectWindow();
    void showEnterPInfos();
    void closeEvent(QCloseEvent *event) override;
    void showAccInfos();
    AccountSelectWindow(QWidget * container,QSize size,int windowBlurRadius);
    static QSize windowSize();
    void changeLoginTypeLabel();
    QSize getTargetSize();
    QWidget* line (QWidget * container);

    void setData(QString acc,QString paw,vector<EnterpriseAccInfo*> info,const QString uid,const QString token);
    ExpandListPop* mEnterPrisePop;
    ExpandListPop* mAccPop;
    QWidget * accSelectItems(QWidget * container);
    QWidget * loginBtn(QWidget * container);
    void onClick(ImageView * iv,QMouseEvent*) override;
    QWidget* enterprSelectItems(QWidget * container);
//    void enterAcc(const QString& connInfo);
    ImageView * comIconBtn(QString path);
    QString getAccLabelText(AccountData*);
//    void onItemClick(ExpandListPop * p , QString& text,int index) override;
    QLabel * addCoverImage(QWidget * container,int windowBlurRadius);
//    void statusChanged(RdpRemoteConnectInfo &info) override;
//    void remoteUIChanged(int ,uint8_t *) override{}
    void setRadius(int radius);
};

#endif // LOGINWINDOW_H
