#ifndef CURLREQUESTOR_H
#define CURLREQUESTOR_H

#include "utils/mainlooper.h"
#include <curl/curl.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <memory>
#include "CppBaseNetRequest.h"
using namespace std;

struct CppMemoryStruct {
  char *memory = nullptr;
  size_t size;
};
class CurlRequestor:public CppBaseNetRequest
{
private:
    std::string paramStr;
    CURL *curl_handle = nullptr;
    std::string mUrl;
    long mStartTime = 0;
    bool mBeCanceled = false;
    bool mReqStarted = false;
//    static inline vector<CurlRequestor*> dd;
    bool mReqCompleted = false;
    std::function<void ()> mDestroyCallBack=nullptr;
    std::mutex mMutex;
    static const int HTTP_METHOD_POST = 1;
    static const int HTTP_METHOD_GET = 0;
    int mHttpMethod = HTTP_METHOD_GET;

    map<std::string,std::string> mBodyParams;
    map<std::string,std::string> mQueryParams;
    struct CppMemoryStruct mChunk;
    int mHttpCode = 0;
    string mResultStr;
    void request();

public:
    void cancel(int cacelCode = -2) override;
    void setDestroyCallBack(std::function<void ()> destroyCallBack){
        this->mDestroyCallBack = destroyCallBack;
    }

    CurlRequestor(){
        curl_global_init(CURL_GLOBAL_ALL);
        curl_handle = curl_easy_init();
//        dd.push_back(this);
    }

    void response(char* data,int code);
    void get(const std::string& url,const std::function<void (string&,int)>& callback) override;
    void post(const std::string &url,const map<std::string,std::string>& body,const map<std::string,std::string>& query,const std::function<void (string&,int)>& callback) override;
    ~CurlRequestor(){
        if(mDestroyCallBack)mDestroyCallBack();
//        dd.erase(find(dd.begin(),dd.end(),this));
//        printf("~CurlRequestor %ld ,dd.size: %d ,%d,%d,%d\n",this,dd.size(),mReqStarted,mBeCanceled,mReqCompleted);
        if(mChunk.memory)free(mChunk.memory);
        curl_easy_cleanup(curl_handle);
    }
};

#endif // CURLREQMANAGER_H
