#include "deviceutils.h"
#include <arpa/inet.h>
#include <net/if.h>
#include <ifaddrs.h>
using namespace std;
#include <sys/ioctl.h>
#define ETH_NAME "eth0"  //  "wlan0"  //如果要获取其他网卡的地址，将这个换为其他网卡名称，比如eth0
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <opensr/systeminfo.h>

DeviceUtils::DeviceUtils()
{

}

std::string DeviceUtils::kernelType(){
    return SystemInfo::kernelType();
}

std::string DeviceUtils::prettyProductName(){
    string pName = SystemInfo::prettyProductName();
    int empIndex = pName.find(" ");
    while(empIndex != -1){
        pName = pName.replace(empIndex,1,"_");
        empIndex = pName.find(" ");
    }
    return pName;
}

std::string DeviceUtils::getLocalMac(){
    int                 sockfd;
    struct ifreq        ifr;

    sockfd = socket(AF_INET, SOCK_DGRAM, 0);
    if (sockfd == -1) {
        exit(1);
    }
    strncpy(ifr.ifr_name, ETH_NAME, IFNAMSIZ);      //Interface name
#ifndef Q_OS_MAC
    if (ioctl(sockfd, SIOCGIFHWADDR, &ifr) == 0) {  //SIOCGIFHWADDR 获取hardware address
        char this_mac[6];
        memcpy(this_mac, ifr.ifr_hwaddr.sa_data, 6);
        return std::string(this_mac);
    }
#endif
    return "0.0.0.0";
}

//废弃
std::string DeviceUtils::getLocalIp(){
    std::string localip = "0.0.0.0";
    struct ifaddrs *addrs;
    if (getifaddrs(&addrs)==0) {
        const struct ifaddrs *cursor = addrs;
        while (cursor != nullptr) {
            if (cursor->ifa_addr->sa_family == AF_INET && (cursor->ifa_flags & IFF_LOOPBACK) == 0)
            {
                //NSString *name = [NSString stringWithUTF8String:cursor->ifa_name];
                //if ([name isEqualToString:@"en0"]) // Wi-Fi adapter
                {
                    localip = inet_ntoa(((struct sockaddr_in *)cursor->ifa_addr)->sin_addr);
//                        localIP = [NSString stringWithUTF8String:inet_ntoa(((struct sockaddr_in *)cursor->ifa_addr)->sin_addr)];
                    break;
                }
            }
            cursor = cursor->ifa_next;
        }
        freeifaddrs(addrs);
    }
    return localip;
}
