#ifndef DEVICEUTILS_H
#define DEVICEUTILS_H
#include <iostream>
//#include <QObject>
//#include <QSysInfo>
#include "pojo/size.h"
#include <QGuiApplication>
#include <QScreen>
#include <QApplication>
#include <QClipboard>
#include <QMimeData>
#include <string>
using namespace std;
class DeviceUtils
{
public:
    enum Platform{
        LINUX,
        MAC,
        WINDOWS
    };
    DeviceUtils();
    static std::string getLocalIp();
    static std::string getLocalMac();
    static std::string kernelType(); //内核名称 : linux
    static std::string prettyProductName();//完整系统以及版本号 Ubuntu 20.04.3 LTS
    static Size screenAvailableSize(){
        QSize size = QGuiApplication::screens()[0]->availableSize();
        return Size(size.width(),size.height());
    }

    static void clearClipboard(){
        QApplication::clipboard()->clear();
    }

    static string getClipboardText(){
        return QApplication::clipboard()->mimeData()->text().toStdString();
    }

    static Platform getPlatform(){
        #ifdef Q_OS_WIN
        return WINDOWS;
        #endif
        #ifdef Q_OS_LINUX
        return LINUX;
        #endif
        #ifdef Q_OS_MAC
        return MAC;
        #endif
    }
};

#endif // DEVICEUTILS_H
