#include "platetoclosepage.h"
#include "QPainter"
#include "QTimeLine"
#include "QDesktopWidget"
#include "QApplication"
#include "QVBoxLayout"
#include "QLabel"
#include "QPushButton"
#include "QTimer"

PlateToClosePage::PlateToClosePage(QSize & size,QWidget* parent ):QWidget(parent){
    setFixedSize(size);
    QDesktopWidget *desktop = QApplication::desktop();
    QRect rect = desktop->availableGeometry();
    _screenSize = QSize(rect.width(),rect.height());
//    setWindowFlags(Qt::FramelessWindowHint|Qt::ToolTip);
//    setAttribute(Qt::WA_TranslucentBackground);

    QVBoxLayout * lay = new QVBoxLayout(this);
    lay->setContentsMargins(0,0,0,0);
    lay->setSpacing(0);
    lay->setAlignment(Qt::AlignCenter);
    QLabel * msgLabel = new QLabel();
    msgLabel->setText("当前账套正在别处登录");
    msgLabel->setStyleSheet("QLabel{color:#cc74caf7;font-size:16px;}");
    lay->addWidget(msgLabel,0,Qt::AlignCenter);
    lay->addSpacing(1);
    _countdownLabel = new QLabel();
    _countdownLabel->setText(QString::number(_countDown)+"秒后客户端将被强制退出");
    _countdownLabel->setStyleSheet("QLabel{color:#cc74caf7;font-size:16px;}");

    lay->addWidget(_countdownLabel,0,Qt::AlignCenter);
    lay->addSpacing(30);
    QPushButton* closeBtn = new QPushButton;
    closeBtn->setFixedSize(200,30);
    closeBtn->setText("关闭");
    connect(closeBtn,&QPushButton::clicked,this,[=]{
        hide();
    });

    closeBtn->setStyleSheet("QPushButton{border:none;border-radius:4px;padding:5px 6px;background-color:#cc74caf7;color:#ffffff}"
                             "QPushButton:hover{background-color:rgb(116,202,247);}");
    lay->addWidget(closeBtn,0,Qt::AlignCenter);

    hide();
}

void PlateToClosePage::showAnim(){
//    QTimeLine* timeLine = new QTimeLine(2000,this);
//    timeLine->setFrameRange(0,100);
    if(_host == nullptr){
        move(_screenSize.width()-width()-20,_screenSize.height()-height() - 20);

    }

    QTimer* timer = new QTimer(this);
    connect(timer,&QTimer::timeout,this,[=]{
        _countDown --;
        if(_countDown < 0){
            timer->stop();
            if(_host){
                _host->close();
            }
            timer->deleteLater();
            return;
        }
        _countdownLabel->setText(QString::number(_countDown)+"秒后客户端将被强制退出");
    });
    timer->start(1000);
    show();
//    connect(timeLine,&QTimeLine::frameChanged,this,[=](int frame){
//        setWindowOpacity(frame / 100.0);
//    });
//    move(_screenSize.width()-width(),_screenSize.height()-height());
//    timeLine->start();
}

void PlateToClosePage::layPosition(){
    if(_host)setGeometry(_host->width()-width()-15,_host->height()-height()-15 ,width(),height());
}

void PlateToClosePage::closeAnim(){

}
void PlateToClosePage::setMessage(QString & msg){

}
void PlateToClosePage::paintEvent(QPaintEvent *event) {
     QPainter painter(this);
     painter.setRenderHint(QPainter::Antialiasing);
     painter.setBrush(QColor(66,66,66,0xee));
     painter.setPen(Qt::NoPen);
     painter.drawRoundedRect(rect(),_radius,_radius);
}
