#ifndef JSONUTILS_H
#define JSONUTILS_H
#include "QByteArray"
#include "QVariantMap"
#include <map>
#include <pojo/jsonvalue.h>
using namespace std;

class QJsonArray;
class QJsonObject;
class JsonUtils
{
public:
    JsonUtils();
    static QVariantList getArray(QByteArray& data);
    static QVariantMap getObject(QByteArray& datas);
    static QString jsonToString(QJsonArray&);
    static QString jsonToString(QJsonObject&);
    static QString jsonToString(QJsonDocument&);
    static QVariant stringToJson(const QString& str);
    static void stringToJson(const std::string& str,map<std::string,JsonValue>& out);

    static QJsonValue jsonValue2QJsonValue(const JsonValue& variant);
    static QJsonObject jsonValueMap2QJsonValue(const map<string,JsonValue>& map);
    static QJsonArray jsonValueList2QJsonValue(const std::vector<JsonValue>&);

    static QVariant jsonValue2variant(const JsonValue& variant);
    static void map2QMap(const map<std::string,JsonValue>& map, QMap<QString,QVariant>& qmap);
    static void list2QList(const vector<JsonValue>& list, QList<QVariant>& qlist);

    static void qMap2Map(const QMap<QString,QVariant>& qmap,map<std::string,JsonValue>& map);
    static void qList2List(const QList<QVariant>& qlist,vector<JsonValue>& list);
    static JsonValue variant2JsonValue(const QVariant& variant);

//    static string jsonValue2String(JsonValue& jsonValue);

    static std::string mapToJsonStr(const std::map<std::string,std::string>& map);
    static std::string mapToJsonStr(const std::map<std::string,JsonValue>& map);

};

#endif // JSONUTILS_H
