#ifndef LOGINPRIVWINDOW_H
#define LOGINPRIVWINDOW_H
#include <QtSvg>
#include <QVBoxLayout>
#include <QLabel>
#include <QBitmap>
#include <QPainter>
#include <QApplication>
#include <QScreen>
#include <QPainter>
#pragma once
#include "widgets/windowclosebtn.cpp"
#include <QGraphicsDropShadowEffect>
#pragma once
#include "widgets/windowminbtn.cpp"
#include <QHBoxLayout>
#include <QPalette>
#include <QSvgRenderer>
#pragma once
#include "widgets/QMCheckBox.cpp"
#pragma once
#include "widgets/QMLineEdit.h"
#include <QDebug>
#pragma once
#include "dataManager/cappsetting.h"
#include <QWidget>
#pragma once
#include "widgets/imageview.h"
#pragma once
#include "widgets/PopupWindow.h"
#include "widgets/expandlistpop.h"
#pragma once

#include "QPalette"
#pragma once
#include "utils/AppUtils.h"
#include "QPoint"
#include "rdp/remotedesktopmanager.h"
#include "widgets/progressdialog.h"
#include "widgets/toastwidget.h"
#include "QTimer"
#include "QGuiApplication"
#include "QGenericArgument"
#include "utils/mainthreadhandler.h"

class MainWindow;
class LoginPriWindow  :public QWidget ,ItemClick,ImageClickListener,ConnectListener{
    Q_OBJECT
private:
    MainThreadHandler*mToastHander;
    MainThreadHandler* mCompHander;
    bool mIsConnectSuc = false;
    QMLineEdit* _accountEdit;
    QWidget* mCoverContainer;
    int _rdpCode = -1;
    QFont _labelFont;
    MainWindow* m_mainwindow = nullptr;
    const QColor _login_btn_bg_color = QColor(91,201,251,235);
    const QColor _login_btn_disclick_bg_color = QColor(91,201,251,165);
    QColor _labelColor = QColor(100,100,100);
    QColor _borderColor = QColor(238,238,238);
    QWidget * _accountLine;
    ToastWidget* _toast;
    int _lrpadding = 50;
    ImageView * _login_btn;
    QWidget * _container;
    QLabel* _loginType = nullptr;
    ProgressDialog* _progdialog;
public:
    LoginPriWindow(QWidget * container,QSize& size,int windowBlurRadius);
    static QSize getLoginPriWindowSize();
    void closeEvent(QCloseEvent *event) override;
    ~LoginPriWindow();
private:
    QLabel * addCoverImage(QWidget * container,int windowBlurRadius);

    void onItemClick(ExpandListPop * p , QString& text,int index) override;

    QWidget* line (QWidget * container);

    void onClick(ImageView *, QMouseEvent *) override;

    void statusChanged(RdpRemoteConnectInfo& info) override;
    void remoteUIChanged(int ,uint8_t *) override;
public:
    Q_INVOKABLE
    void toastMsg(QString& s);
    Q_INVOKABLE
    void connectCompleted(QString s,bool suc);
    QWidget * loginBtn(QWidget * container);
    QWidget* accountEditLine(QWidget * container);
    ImageView * comIconBtn(const QString& path);
    void setMainWindow(MainWindow * window);
    void setRadius(int radius);
};
#endif
