#include "loginwindow.h"
#include <QtSvg>
#include <QVBoxLayout>
#include <QLabel>
#include <QBitmap>
#include <QPainter>
#include <QApplication>
#include <QScreen>
#include <QPainter>
//#include "widgets/windowclosebtn.cpp"
#include <QGraphicsDropShadowEffect>
//#include "widgets/windowminbtn.cpp"
#include <QHBoxLayout>
#include <QPalette>
#include <QSvgRenderer>
#include "widgets/QMCheckBox.cpp"
#include "widgets/QMLineEdit.h"
#include "dataManager/cappsetting.h"

#include "QPalette"
#include "utils/AppUtils.h"
#include "QPoint"
#include "loginprivwindow.h"

//#include "dataManager/net/curlreqmanager.h"
#include "utils/jsonutils.h"
#include "presenters/cproductpresenter.h"
//#include "selectcountrycodewindow.h"
#include "mainwindow.h"

#include "pojo/enterpriseaccinfo.h"
#include "accountselectwindow.h"
#include "widgets/clickedlabel.h"
#include "utils/widgetutils.h"
#include "manager/rdpmanager.h"
#include "dataManager/cppurls.h"

using namespace std;
extern CAppSetting* g_cappSetting;

void LoginWindow::setMainWindow(MainWindow* host){
    this->mHost = host;
    if(mHost->isSuportAutoLogin() && g_cappSetting->isAutoLogin() && !_accountEdit->text().trimmed().isEmpty() && !mPwdEdit->text().trimmed().isEmpty()){
        QTimer::singleShot(1500,this,[=]{
            if(!g_cappSetting->isAutoLogin())return;
            onClick(nullptr,nullptr);
        });
    }
}

void LoginWindow::changedLoginMode(int mode){////0:普通登录 1:验证码登录
    mLoginMode = mode;
    mPwdLoginModeLay->setVisible(mode == 0);
    mPawLoginOprLay->setVisible(mode == 0);
    mVerLoginOprLay->setVisible(mode == 1);
    mVerLoginModeLay->setVisible(mode == 1);
}

LoginWindow::~LoginWindow(){
}

LoginWindow::LoginWindow(QWidget * container,QSize& size,int windowBlurRadius):QWidget(container)
{
    setFixedSize(size);
    this->_windowBlurRadius = windowBlurRadius;
    this->_container = this;
    _labelFont.setPixelSize(15);
    _labelFont.setWeight(0);

//    _labelFont.setFamily("宋体");

    QVBoxLayout *vBox = new QVBoxLayout;

    vBox->setContentsMargins(0,0,0,0);

    vBox->setSpacing(0);
    QWidget* coverImage = addCoverImage(_container,windowBlurRadius);//顶部巨幅
    coverImage->setObjectName("coverImage");
    mCoverContainer = new QWidget();
    QHBoxLayout* containerLay = new QHBoxLayout(mCoverContainer);
    containerLay->setContentsMargins(0,0,0,0);
    containerLay->setSpacing(0);
    containerLay->addWidget(coverImage);
    vBox->addWidget(mCoverContainer);

//    QLineEdit * bo = new QLineEdit;
//    bo->setAttribute(Qt::WA_MacShowFocusRect,false);
//    bo->setStyleSheet("QLineEdit{border-width:0;border-style:outset;margin-left:25}");

//    vBox->addWidget(bo);

    vBox->setContentsMargins(0,0,0,0);

    vBox->addSpacing(7);

    ClickedLabel* regbtn = new ClickedLabel;
    QFont regfont;
    regfont.setPixelSize(13);
    regbtn->setFont(regfont);
    regbtn->setText("立即注册");

    connect(regbtn,&ClickedLabel::clicked,this,[=]{
        AppUtils::openUrlByDefaultBrower(CppUrls::getUrlRegister());
    });

    regbtn->setStyleSheet("QLabel{color:#5bc9ff}"
                          "QLabel:hover{color:#39a7ff}");

    QHBoxLayout* regLay = new QHBoxLayout;
    regLay->setSpacing(0);
    regLay->setContentsMargins(0,0,_lrpadding+5,0);
    regLay->addWidget(regbtn,0,Qt::AlignRight);

    vBox->addLayout(regLay,Qt::AlignRight);

    vBox->addWidget(accountEditLine(_container));
    vBox->addWidget(_accountLine = line(_container));
    vBox->addSpacing(7);
    mPwdLoginModeLay = pwdEditLine(_container);
    vBox->addWidget(mPwdLoginModeLay);
    mVerLoginModeLay = verCodeLay(_container);
    vBox->addWidget(mVerLoginModeLay);

    vBox->addSpacing(4);
    vBox->addWidget(line(_container));

//    vBox->addSpacing(5);
    mPawLoginOprLay = checks(_container);
    mVerLoginOprLay = toPwdLoginLay(_container);
    QWidget* checksWidget = new QWidget;
    QVBoxLayout* checksLay = new QVBoxLayout(checksWidget);
    checksLay->setSpacing(0);
    checksLay->setContentsMargins(0,0,0,0);
    checksLay->addWidget(mPawLoginOprLay);
    checksLay->addWidget(mVerLoginOprLay);
    checksWidget->setFixedHeight(37);

    vBox->addWidget(checksWidget);
    vBox->addSpacing(2);
    vBox->addWidget(loginBtn(_container));
    setLayout(vBox);

    vBox->addStretch();
    QWidget* pageWidget = new QWidget(_container);//窗口content
    pageWidget->setLayout(vBox);

    ImageView* qrBtn = new ImageView(pageWidget);
    connect(qrBtn,&ImageView::clicked,this,[=]{
        mHost->setShowMode(3);
    });

    QPixmap map = QPixmap(":/images/icon_qr_login.png");
    qrBtn->setPixMapSrc(map);

    double pr = QGuiApplication::primaryScreen()->devicePixelRatio();
    qrBtn->setGeometry(mCoverSize.width()/pr - map.width(),mCoverSize.height()/pr,map.width(),map.height());

    _loginType = new QLabel(_container);
    QFont font;
    font.setPixelSize(14);
    _loginType->setFont(font);
    QPalette palette;
    palette.setColor(QPalette::WindowText,Qt::white);
    _loginType->setPalette(palette);
    changeLoginTypeLabel();
    _loginType->setGeometry(10,5,160,40);
    changeLoginTypeLabel();

    _toast = new ToastWidget(this);
    changedLoginMode(0);
}

void LoginWindow::setRadius(int radius){
    auto child = mCoverContainer->findChild<QWidget*>("coverImage");
    QWidget* cover = addCoverImage(_container,radius);

    mCoverContainer->layout()->removeWidget(child);
    mCoverContainer->layout()->addWidget(cover);
    child->setParent(nullptr);
    child->deleteLater();
    cover->setObjectName("coverImage");
}

QSize LoginWindow::windowSize(){
    return QSize(420,332);
}

void LoginWindow::changeLoginTypeLabel(){
    _loginType->setText(g_cappSetting->isExpMode() ? "登录-公有云-体验版" : "登录-公有云");
}

void LoginWindow::onItemClick(ExpandListPop * p , QString& text,int index) {
    p->dismiss();
    if(_accountEdit){
        _accountEdit->setText(text);
    }

    if(g_cappSetting->isRememberPaw()){
        vector<vector<string>> loginHistory = g_cappSetting->getLoginHistoryManager()->getPubCloudAcc();
        for(vector<string>& data : loginHistory){
            if(QString(data[0].c_str()) == text){
                QString paw = data.size() == 1 ? "" :  QString(g_cappSetting->getLoginHistoryManager()->getEncodePaw(data[1]).c_str());
                mPwdEdit->setText(paw);
            }
        }
    }
}

//QSize LoginWindow::getTargetSize(){
//    return QSize(431,331);
//}

QWidget* LoginWindow::line (QWidget * container){
    ImageView* split = new ImageView;
    split->setFixedSize(container->width() - _lrpadding * 2,1);
    split->setBackgroudColor(_borderColor);
    QHBoxLayout* lay = new QHBoxLayout;
    lay->setContentsMargins(0,0,0,0);
    lay->setSpacing(0);

    lay->addWidget(split);
    QWidget* line = new QWidget;
    line->setLayout(lay);
    return line;
}


QWidget * LoginWindow::checks(QWidget * container){
    QWidget* checkopts = new QWidget;
    QHBoxLayout * lay = new QHBoxLayout;
    lay->setAlignment(Qt::AlignRight|Qt::AlignVCenter);
    lay->setContentsMargins(0,0,0,0);
    lay->setSpacing(0);

    checkopts->setLayout(lay);

    QString fontColor = "QCheckBox {color : rgb(100,100,100)}";

    QMCheckBox* wPwd = new QMCheckBox;

    wPwd->setTextFromTr(QObject::tr("remember_password"),"remember_password");
    wPwd->setContentsMargins(0,0,0,0);
    wPwd->setChecked(g_cappSetting->isRememberPaw());
    QFont font(_labelFont);
    font.setPixelSize(13);

    wPwd->setFont(font);
    wPwd->setStyleSheet(fontColor);
    lay->addWidget(wPwd);
    lay->addSpacing(9);
    QObject::connect(wPwd,&QCheckBox::stateChanged,this,[=](int status){
        g_cappSetting->setRememberPaw(status == Qt::CheckState::Checked);
    });

    QMCheckBox * autoLogin = new QMCheckBox();
    autoLogin->setChecked(g_cappSetting->isAutoLogin());
    autoLogin->setTextFromTr(QObject::tr("auto_login"),"auto_login");
    autoLogin->setStyleSheet(fontColor);
    autoLogin->setFont(font);
    autoLogin->setContentsMargins(0,0,0,0);
    lay->addWidget(autoLogin);
    checkopts->setLayout(lay);

    connect(autoLogin,&QCheckBox::stateChanged,this,[=](int status){
       g_cappSetting->setAutoLogin(status == Qt::CheckState::Checked);
    });

    lay->addSpacing(9);
    ClickedLabel* fdPaw = new ClickedLabel;

    connect(fdPaw,&ClickedLabel::clicked,this,[=]{
        AppUtils::openUrlByDefaultBrower(CppUrls::getUrlModifyPaw());
    });

    fdPaw->setText("忘记密码");
    fdPaw->setFont(font);
    fdPaw->setStyleSheet("QLabel{color:#888888}"
                         "QLabel:hover{color:#555555}");
    lay->addWidget(fdPaw);
    lay->addSpacing(7);

    QWidget* line = new QWidget;
    line->setFixedSize(2,12);
    line->setStyleSheet("background-color:#bbbbbb");
    lay->addWidget(line);

    lay->addSpacing(7);

    ClickedLabel* vaLogin = new ClickedLabel;
    vaLogin->setText("验证码登录");
    vaLogin->setStyleSheet("QLabel{color:#888888}QLabel:hover{color:#555555}");
    vaLogin->setFont(font);
    lay->addWidget(vaLogin);

    connect(vaLogin,&ClickedLabel::clicked,this,[=]{
        changedLoginMode(1);
    });

    lay->addSpacing(_lrpadding);

    return checkopts;
}

QWidget * LoginWindow::toPwdLoginLay(QWidget * container){
    QWidget* content = new QWidget;
    QHBoxLayout* lay = new QHBoxLayout(content);
    lay->setSpacing(0);
    lay->setContentsMargins(0,0,_lrpadding,0);
    ClickedLabel* toPawLogin = new ClickedLabel;
    toPawLogin->setText("密码登录");

    connect(toPawLogin,&ClickedLabel::clicked,this,[=]{
        changedLoginMode(0);
    });

    toPawLogin->setStyleSheet("QLabel{color:#888888}QLabel:hover{color:#555555}");
    QFont font;
    font.setPixelSize(13);
    toPawLogin->setFont(font);
    lay->addWidget(toPawLogin,0,Qt::AlignRight);
    return content;
}

QWidget * LoginWindow::verCodeLay(QWidget * container){
    QWidget* content = new QWidget;
    int itmHeight = 25;
    QHBoxLayout* layout = new QHBoxLayout(content);
    layout->setContentsMargins(_lrpadding,0,_lrpadding,0);

    layout->setSizeConstraint(QLayout::SetMaximumSize);
    layout->setSpacing(0);
    mVerCodeEdit = new QMLineEdit;
    mVerCodeEdit->setFont(_labelFont);
    QPalette palette;
    palette.setColor(QPalette::Text,_labelColor);
    mVerCodeEdit->setPalette(palette);

    mVerCodeEdit->setFixedHeight(itmHeight);
    mVerCodeEdit->setPlaceholderText("请输入验证码");
    mVerCodeEdit->setAttribute(Qt::WA_MacShowFocusRect,false);
    mVerCodeEdit->setStyleSheet("QLineEdit{border-width:0;border-style:outset;margin-left:5}");
    layout->addWidget(mVerCodeEdit,1);

    _btnSendVer = new ClickedLabel;
    QFont font;
    font.setPixelSize(14);
    _btnSendVer->setFont(font);
    _btnSendVer->setStyleSheet("QLabel{color:#666666;}QLabel:hover{color:#333333;}");
    _btnSendVer->setText("发送验证码");

    connect(_btnSendVer,&ClickedLabel::clicked,this,[=]{
//        verCountDown();
        if(_count > 0)return;
        mAccountPresenterPtr = make_unique<AccountPresenter>();
        QString phone = _accountEdit->text();
        ProgressDialog * pd = new ProgressDialog(this);
        pd->showDialog("发送中..");
        string phoneStr = phone.toStdString();
        mAccountPresenterPtr.get()->sendCaptcha(phoneStr,[=](bool success,const string& errMsg)->void{
            pd->dismiss();
            if(success){
                verCountDown();
            }else{
                _toast->showMesssage(QString(errMsg.c_str()));
            }
        });
    });

    _btnSendVer->setAlignment(Qt::AlignCenter);
    _btnSendVer->setFixedSize(WidgetUtils::getTextWidth(font,_btnSendVer->text()),itmHeight);

    layout->addWidget(_btnSendVer);
    return content;
}

void LoginWindow::verCountDown(){
    _count = 60;
    _btnSendVer->setText(QString::number(_count)+"s");
    QTimer* timer = new QTimer(this);
    connect(timer,&QTimer::timeout,this,[=]{
        _count --;
        if(_count == 0){
            timer->stop();
            _btnSendVer->setText("发送验证码");
            return;
        }
        _btnSendVer->setText(QString::number(_count)+"s");
    });
    timer->start(1000);
}

QWidget * LoginWindow::pwdEditLine(QWidget * container){
    QWidget* content = new QWidget;
    int itmHeight = 25;
    QHBoxLayout* layout = new QHBoxLayout;
    layout->setContentsMargins(_lrpadding,0,_lrpadding,0);

    layout->setSizeConstraint(QLayout::SetMaximumSize);
    layout->setSpacing(0);

    mPwdEdit = new QMLineEdit;
    mPwdEdit->setFont(_labelFont);
    QPalette palette;
    palette.setColor(QPalette::Text,_labelColor);
    mPwdEdit->setPalette(palette);
    mPwdEdit->setEchoMode(QLineEdit::Password);

    mPwdEdit->setFixedHeight(itmHeight);
    mPwdEdit->setPlaceholderTextFromTr(QObject::tr("pl_input_pwd"),"pl_input_pwd");
    mPwdEdit->setAttribute(Qt::WA_MacShowFocusRect,false);
    mPwdEdit->setStyleSheet("QLineEdit{border-width:0;border-style:outset;margin-left:5}");

    connect(mPwdEdit,&QMLineEdit::onKeyDown,this,[=](int key){
        if(key == Qt::Key_Return){
            onClick(nullptr,nullptr);
        }
    });

    layout->addWidget(mPwdEdit,1);

    ImageView*imageView = new ImageView;
    imageView->setFixedSize(itmHeight,itmHeight);
    imageView->setPadding(3,3,3,3);
    imageView->setRadius(100);
    imageView->waveCenter(true);
    connect(imageView,&ImageView::mouseEvent,this,[=](int code){
        if(code == 1){
            mPwdEdit->setEchoMode(QLineEdit::Normal);
        }else if(code == 3){
            mPwdEdit->setEchoMode(QLineEdit::Password);
        }
    });

    QPixmap map = QPixmap(":/images/pwd_show.png");
//    QLabel * label = new QLabel;
//    label->setPixmap(map);
//    layout->addWidget(label);
    imageView->setPixMapSrc(map);
    layout->addWidget(imageView);
    layout->addSpacing(3);

    if(g_cappSetting->isRememberPaw()){
        vector<vector<string>> loginHistory = g_cappSetting->getLoginHistoryManager()->getPubCloudAcc();
        if(loginHistory.size() > 0 && loginHistory[0].size() > 1){
            string paww = g_cappSetting->getLoginHistoryManager()->getEncodePaw(loginHistory[0][1]);
            if(paww.size() > 0){
                mPwdEdit->setText(QString(paww.c_str()));
            }
        }
    }

    content->setLayout(layout);
    return content;
}

QWidget * LoginWindow::loginBtn(QWidget * container){
    QHBoxLayout* lay = new QHBoxLayout;
    ImageView * btn = new ImageView;
    btn->setFixedSize(container->width() - _lrpadding * 2,29);
    btn->setBackgroudColor(QColor(91,201,251,150));
    btn->setLabel(QObject::tr("login"),"login");
    btn->setClipRadius(5);
    btn->setFontColor(Qt::white);
    btn->setFont(_labelFont);
    lay->addWidget(btn);
    lay->setSpacing(0);
    lay->setContentsMargins(0,5,0,0);
    QWidget *w = new QWidget;
    w->setLayout(lay);

    btn->setOnClickListener(this);
    return w;
}

void LoginWindow::onClick(ImageView * ,QMouseEvent*){
    QString acc = _accountEdit->text().trimmed();
     if(acc.isEmpty()){
         _toast->showMesssage("请输入用户名");
         return;
     }
    QString paw = mPwdEdit->text().trimmed();
     if(mLoginMode == 0){
         if(paw.isEmpty()){
             _toast->showMesssage("请输入密码");
             return;
         }
     }else{
         QString ver = mVerCodeEdit->text().trimmed();
         if(ver.isEmpty()){
             _toast->showMesssage("请输入验证码");
             return;
         }
     }

     _progdialog = new ProgressDialog(this);
     _progdialog->setRadius(g_cappSetting->getWindowRadius());
     _progdialog->showDialog("登录中..");
     mProductPresenterPtr = make_unique<CProductPresenter>();
     mProductPresenterPtr.get()->loginAndCheck2EnterRdp(acc.toStdString(),[=](bool suc,bool finished,const string& msg){
        if(suc){
            if(!finished){
                _progdialog->setLabel(QString(msg.c_str()));
            }else{
                goSelectAccWindow();
            }
        }else{
            _progdialog->dismiss();
            _toast->showMesssage(QString(msg.c_str()));
        }
     },[=](ReponseResult<RdpConnectResult>& connectResult){
       if(!connectResult.isSuc()){
           _progdialog->dismiss();
           if(mProductPresenterPtr.get()->getLoginenterpriseInfos().size() > 1){
                goSelectAccWindow();
           }else{
                _toast->showMesssage(QString(connectResult.getErrMsg().c_str()));
           }
        }else{
           RdpConnectResult connRes = connectResult.getData();
           if(!connRes.isFinished){
               _progdialog->setLabel(QString(connRes.msg.c_str()));
           }else{
               _progdialog->dismiss();
               if(connRes.isWaring){
                   AlertDialog* alert = new AlertDialog(this);

                   alert->setFixedSize(this->size());
                   alert->setRadius(_windowBlurRadius);
                   vector<QString> btns ;
                   if(connRes.canVisAcc){
                       btns = {"取消","确定"};
                   }else{
                       btns = {"确定"};
                   }
                   alert->setButtons(btns);
                   alert->setTitle("提示");
                   alert->setMessage(QString(connRes.msg.c_str()));
                   connect(alert,&AlertDialog::buttonClick,this,[=](int index){
                       alert->dismiss();
                       alert->setParent(nullptr);
                       alert->deleteLater();
                       if(index == 1){
                           _progdialog = new ProgressDialog(this);
                           _progdialog->setRadius(g_cappSetting->getWindowRadius());
                            _progdialog->showDialog("进入账套中..");
                           mProductPresenterPtr.get()->enterAcc();
                       }
                   });

                   alert->show();
               }else{
                   _progdialog->dismiss();
                   if(connRes.success){
                        mHost->closeMainWindow();
                   }else{
                       _toast->showMesssage(QString(connRes.msg.c_str()));
                   }
               }
           }
       }
     },g_cappSetting->isAutoLogin(),
    mLoginMode == 0 ? paw.toStdString() : "","",mVerCodeEdit->text().trimmed().toStdString());
}

void LoginWindow::goSelectAccWindow(){
    LoginResult loginResult = mProductPresenterPtr.get()->getLoginResult();
    vector<EnterpriseAccInfo*> vec = mProductPresenterPtr.get()->getLoginenterpriseInfos();
    _progdialog->dismiss();
    string uid = loginResult.uid;
    string token = loginResult.token;
    string enPaw = mPwdEdit->text().trimmed().toStdString();
    mHost->getAccountSelectWindow()->setData(_accountEdit->text().trimmed(),QString(RemoteDesktopManager::encodePaw(enPaw).c_str()),vec,QString(uid.c_str()),QString(token.c_str()));
    mHost->setShowMode(4);
}

QWidget* LoginWindow::accountEditLine(QWidget * container){
    QWidget* content = new QWidget;
    int itmHeight = 25;

    QHBoxLayout* layout = new QHBoxLayout;
    layout->setContentsMargins(_lrpadding,0,_lrpadding,0);

    layout->setSizeConstraint(QLayout::SetMaximumSize);
    layout->setSpacing(0);

//    mCountryCode = new ImageView;
//    connect(mCountryCode,&ImageView::clicked,this,[=]{
//        SelectCountryCodeWindow* window = new SelectCountryCodeWindow;
//        connect(window,&SelectCountryCodeWindow::selected,this,[=](SelectCountryCodeWindow::CountryCode code){
//            mCountryCode->setLabel("+"+QString::number(code.num),"");
//        });

//        QPoint point = mHost->pos();
//        int x = point.x();
//        int y = point.y();
//        int showX ;
//        if(x < window->width()*1.5){
//            showX = x + mHost->width() - _windowBlurRadius+1;
//        }else{
//            showX = x - window->width()+_windowBlurRadius-1;
//        }
//        window->show(showX,y + _windowBlurRadius);
//    });

//    mCountryCode->setLabel("+86","");
//    mCountryCode->waveCenter(true);
//    mCountryCode->setRadius(100);
//    mCountryCode->setLabelFont(_labelFont);
//    mCountryCode->setFontColor(_labelColor);
//    mCountryCode->setFixedSize(41,41);

//    layout->addWidget(mCountryCode);
//    layout->addSpacing(5);
    ImageView * split = new ImageView;
    split->setFixedSize(1,itmHeight);
    split->setBackgroudColor(_borderColor);

//    layout->addWidget(split);
//    layout->addSpacing(10);

    _accountEdit = new QMLineEdit;
    _accountEdit->setFont(_labelFont);

    QPalette palette;
    palette.setColor(QPalette::Text, _labelColor);
    _accountEdit->setPalette(palette);
    _accountEdit->setFixedHeight(itmHeight);

    _accountEdit->setPlaceholderTextFromTr(QObject::tr("pl_input_uname"),"pl_input_uname");
    _accountEdit->setAttribute(Qt::WA_MacShowFocusRect,false);
    _accountEdit->setStyleSheet("QLineEdit{border-width:0;border-style:outset;margin-left:5}");
    layout->addWidget(_accountEdit);

    vector<vector<string>> loginHistory = g_cappSetting->getLoginHistoryManager()->getPubCloudAcc();

//    if(!loginHistory.isEmpty()){
        mAccExpBtn = comIconBtn(":/images/expand_more.svg");
        mAccExpBtn->setTag(this);

        connect(mAccExpBtn,&ImageView::clicked,this,[=](){
            vector<vector<string>> loginHistory = g_cappSetting->getLoginHistoryManager()->getPubCloudAcc();
            if(loginHistory.size() == 0){
                _toast->showMesssage("没有登录记录！");
                return;
            }
            LoginWindow * lWindow = this;
    //            QPoint p11 = img->mapToGlobal(lWindow->_accountLine->pos());
            QWidget * line = lWindow->_accountLine;

            int l = line->pos().x();
            int t = line->pos().y();
            QWidget * parent = (QWidget*)line->parent();
            while(parent != nullptr && parent->isWidgetType()){
                l += parent->pos().x();
                t += parent->pos().y();
                parent = (QWidget*)parent->parent();
            }

            ExpandListPop* p = new ExpandListPop(303+26);
            p->setItemPadding(12,0,12,0);

            QList<QString> list ;
            QList<ExMenuButtonInfo> exList;

            for(vector<string> logData : loginHistory){
                list.append(QString(logData[0].c_str()));

                ExMenuButtonInfo exInfo;
                exInfo.path = ":images/ic_clear.svg";
                exInfo.isSvg = true;
                exInfo.width = 30;
                exInfo.height = 30;
                exInfo.paddingTop = 8;
                exInfo.paddingLeft = 8;
                exInfo.paddingRight = 8;
                exInfo.paddingBottom = 8;
                exList.push_back(exInfo);
            }

            p->setItems(list,exList);
            p->showPop(l+lWindow->_lrpadding-4,t+4);
            p->setItemClickListener(this);
            connect(p,&ExpandListPop::itemMenuClick,p,[=](int index){
                vector<vector<string>> history = g_cappSetting->getLoginHistoryManager()->getPubCloudAcc();
                if(history.size() > index){
                    g_cappSetting->getLoginHistoryManager()->deletePubCloudAcc(history[index][0]);
                    p->removeItem(index);
                    history.erase(history.begin()+index);
                }
//                if(history.isEmpty()){
////                    this->mAccExpBtn->setVisible(false);
//                }
            });
        });

        layout->addWidget(mAccExpBtn);
        if(loginHistory.size() > 0)_accountEdit->setText(QString(loginHistory[0][0].c_str()));
//    }else{
//        QWidget *empty = new QWidget;
//        empty->setFixedSize(1,35);
//        layout->addWidget(empty);
//    }

    content->setLayout(layout);
//    content->setFixedSize(container->width() , itmHeight);
    return content;
}

ImageView * LoginWindow::comIconBtn(const QString& path){
    ImageView*imageView = new ImageView;
    imageView->setFixedSize(35,35);
    imageView->setRadius(100);
    imageView->waveCenter(true);
    imageView->setPadding(7,7,7,7);
    imageView->setSvgPixMapSrc(path,35,35);

    return imageView;
}

QLabel * LoginWindow::addCoverImage(QWidget * container,int windowBlurRadius){
    QLabel * converImage = new QLabel;
    QPixmap pixmap(":/images/login_banner.png");

    double pr = QGuiApplication::primaryScreen()->devicePixelRatio();

    QPixmap sp = pixmap.scaled(container->width() * pr,1,Qt::KeepAspectRatioByExpanding);
    sp.setDevicePixelRatio(pr);

    int off = sp.height() * .07;
    QPixmap map(sp.width(),sp.height() - off * 2);
    mCoverSize = map.size();
    map.fill(Qt::transparent);
    map.setDevicePixelRatio(sp.devicePixelRatio());
    QPainter mapPainter(&map);
    QPainterPath path;
    mapPainter.setPen(Qt::NoPen);

    path.addRoundedRect(0,0,container->width(),sp.height() ,windowBlurRadius,windowBlurRadius);
    mapPainter.setRenderHints(QPainter::Antialiasing | QPainter::SmoothPixmapTransform);
    mapPainter.setClipPath(path);
    mapPainter.drawPixmap(0,-off/2,sp);
    mapPainter.setCompositionMode(QPainter::CompositionMode_DestinationIn);

    QPixmap conver(sp.width(),sp.height());
    conver.setDevicePixelRatio(pr);
    conver.fill(Qt::transparent);
    QPainter converPainter(&conver);
    converPainter.setPen(Qt::NoPen);
    converPainter.setBrush(Qt::black);
    converPainter.setRenderHints(QPainter::Antialiasing | QPainter::SmoothPixmapTransform);
    converPainter.drawRoundedRect(0,0,container->width(),sp.height(),windowBlurRadius,windowBlurRadius);
    mapPainter.drawPixmap(0,0,conver);

    converImage->setPixmap(map);
    return converImage;
}


