#ifndef LOGINWINDOW_H
#define LOGINWINDOW_H
#include <QWidget>
#include "widgets/imageview.h"
#include "widgets/PopupWindow.h"
#include "widgets/expandlistpop.h"
#include "widgets/toastwidget.h"
#include "QLabel"
#include <memory>
#include "widgets/clickedlabel.h"
#include "presenters/cproductpresenter.h"
#include "presenters/accountpresenter.h"

class QMLineEdit;
class MainWindow;
class ProgressDialog;
class EnterpriseAccInfo;
class LoginWindow  :public QWidget ,ItemClick,ImageClickListener{
private:
    int _windowBlurRadius;
    int _count = -1;
    ToastWidget* _toast;
    ClickedLabel* _btnSendVer;
    ProgressDialog* _progdialog;
    ImageView * mAccExpBtn = nullptr;
    QLabel* _loginType = nullptr;
    QMLineEdit* _accountEdit;
    QFont _labelFont;
    QColor _labelColor = QColor(100,100,100);
    QColor _borderColor = QColor(238,238,238);
    QWidget * _accountLine;
    int _lrpadding = 50;
    QWidget * _container;
//    ImageView * mCountryCode;
    MainWindow* mHost;
    int mLoginMode ;//0:普通登录 1:验证码
    QMLineEdit* mPwdEdit;
    QMLineEdit* mVerCodeEdit;
    QSize mCoverSize;
    QWidget* mPwdLoginModeLay;
    QWidget* mVerLoginModeLay;
    QWidget* mPawLoginOprLay;
    QWidget* mVerLoginOprLay;
    QWidget* mCoverContainer;
    unique_ptr<CProductPresenter> mProductPresenterPtr;
    unique_ptr<AccountPresenter> mAccountPresenterPtr;
    void verCountDown();
    void changedLoginMode(int mode);//0:普通登录 1:验证码
public:
    void setMainWindow(MainWindow* host);
    ~LoginWindow();
    LoginWindow(QWidget * container,QSize& size,int windowBlurRadius);
    static QSize windowSize();
    void changeLoginTypeLabel();
//    QSize getTargetSize();
    QWidget* line (QWidget * container);
    QWidget * checks(QWidget * container);
    QWidget * pwdEditLine(QWidget * container);
    QWidget * verCodeLay(QWidget * container);
    QWidget * toPwdLoginLay(QWidget * container);
    QWidget * loginBtn(QWidget * container);
    void onClick(ImageView * iv,QMouseEvent*) override;
    QWidget* accountEditLine(QWidget * container);
    ImageView * comIconBtn(const QString& path);
    void onItemClick(ExpandListPop * p , QString& text,int index) override;
    QLabel * addCoverImage(QWidget * container,int windowBlurRadius);
    void setRadius(int radius);
    void goSelectAccWindow();
};

#endif // LOGINWINDOW_H
