#ifndef MAINLOOPER_H
#define MAINLOOPER_H
using namespace std;
#include <pojo/jsonvalue.h>
#include <QObject>
#include <vector>
#include <memory>
#include <mutex>
class MainLooper : public QObject
{
    Q_OBJECT
private:
    vector<void*> mAny;
    vector<JsonValue> mValues;
    mutex mux;
    std::function<void ()> mCallback;
    Q_INVOKABLE
    void run();
public:
    explicit MainLooper(std::function<void ()> fun = nullptr,QObject *parent = nullptr);
    void addTask(void* data = nullptr);
    void addCarry(void* any){
        mux.lock();
        mAny.emplace_back(any);
        mux.unlock();
    }

    void addCarry(const JsonValue& value){
        mux.lock();
        mValues.emplace_back(value);
        mux.unlock();
    }

    vector<JsonValue>* getValues(){
        return &mValues;
    }

    //只用于主线程
    vector<void*> getCarry(){
        return mAny;
    }

    ~MainLooper(){
        mCallback = nullptr;
    }
signals:

};

#endif // MAINLOOPER_H
