#ifndef MAINWINDOW_H
#define MAINWINDOW_H
#include "qrloginwindow.h"
#include <QMainWindow>
#include <loginwindow.h>
#include "logincontain.cpp"
#include "aboutwindow.h"
#include "QGraphicsDropShadowEffect"

#include <memory>

QT_BEGIN_NAMESPACE
using namespace std;
namespace Ui { class MainWindow; }
QT_END_NAMESPACE
class TansByYWindow;
class LoginPriWindow;
class AccountSelectWindow;
class WindowMinButton;
class WindowCloseButton;
class MainWindow : public QMainWindow,public PopupMenuWindow::SelectPopItemListener,public ImageClickListener
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr,bool supAutoLogin = true);
    ~MainWindow();

    void setShowMode(int en);
    AccountSelectWindow* getAccountSelectWindow(){
        return mAccSelectWindow;
    }
    LoginPriWindow* mLoginPriPage;
    QrLoginWindow* mQrWindow;
    LoginWindow * mLoginPage;
    AboutWindow* mAboutWindow;
    AccountSelectWindow* mAccSelectWindow;
    void setTansByYWindow(TansByYWindow* w);
    void popSelected(PopupMenuWindow* pop,int index) override;
    QWidget* optButtons(QWidget * container);
    void setWindowExFunButtonClickable(bool en);
    LoginContain* m_contain;
    void mouseMoveEvent(QMouseEvent *event) override;
    void mouseReleaseEvent(QMouseEvent *event) override;
    void leaveEvent(QEvent *event) override;
    void mousePressEvent(QMouseEvent *event) override;
    void onClick(ImageView *, QMouseEvent *) override;
    void closeEvent(QCloseEvent *event) override;
    QPoint mainWindowPos();
    QSize mainWindowSize();
    void setMainWindowFixSize(QSize size);
    void closeMainWindow();
    void funClick(ImageView* img, QMouseEvent * e);
    void boundGraphicsEffectEnable(bool enable);
    bool isSuportAutoLogin(){
        return mSuportAutoLogin;
    }
private:
    void changeEvent(QEvent *) override;
    void toSetting();
    int blurRadius = 14;
    bool mSuportAutoLogin = true;
    unique_ptr<QObject> ptr;
    int mShowMode = 1;
    WindowMinButton * minBtn = nullptr;
    WindowCloseButton* mCloseButton = nullptr;
    Ui::MainWindow *ui;
    TansByYWindow* mHostWindow;
    ImageView* m_exFunBtn = nullptr;
    bool _canMoveWindow = false;

    QPoint mMovePosition;
    QGraphicsDropShadowEffect * mShadow_effect;
    void setWindowRoundable(bool enable);
};
#endif // MAINWINDOW_H
