#include "appinstaller.h"

#include <QTranslator>
#include <QFontDatabase>
#include <QFont>
#include "../mainwindow.h"
#include "opensr/process.h"

#ifdef Q_OS_LINUX
#ifndef USED_QT_SHARED_LIB
    #include <QtCore/QtPlugin>
    Q_IMPORT_PLUGIN(QComposePlatformInputContextPlugin)
    Q_IMPORT_PLUGIN(QIbusPlatformInputContextPlugin)
    Q_IMPORT_PLUGIN(QFcitxPlatformInputContextPlugin)
#endif
#endif

#ifdef Q_OS_MACOS
//#include <QtCore/qplugin.h>

#endif


void AppInstaller::initApp(){
    mApp = new QApplication(mArc, mArgv);

//    mApp->setApplicationName("金蝶KIS云");
//    mApp->setApplicationDisplayName("金蝶KIS云");

    QTranslator* translator = new QTranslator;//无需回收，由进程退出自动回收
    translator->load(":/res/lang/zh_cn.qm");
    QApplication::installTranslator(translator);

    int fontId = QFontDatabase::addApplicationFont(":/res/fontslib/DroidSansFallbackFull.ttf");

    if(fontId >-1){
        QString msyh = QFontDatabase::applicationFontFamilies(fontId).at(0);
        QFont* font = new QFont(msyh);
        font->setPixelSize(15);
        QApplication::setFont(*font);
    }
}

void AppInstaller::startMainWindow(){
    MainWindow* w = new MainWindow;
    w->show();
    w->raise();

    Process process;
    std::string commond = CAppSetting::getWebServPath();
    process.excute(commond);
}

void AppInstaller::startMainWindowAndAcitived(QWidget *parent,bool supAutoLogin){
    MainWindow* w = new MainWindow(parent,supAutoLogin);
    w->show();
    w->raise();
    w->activateWindow();
}

int AppInstaller::execute(){
    return mApp->exec();
}
