#include "ttimer.h"

TTimer::TTimer(std::function<void ()> func):QObject(nullptr)
{
//    printf("new TTimer \n");
    mTimerFunc = func;
    mTimer = new QTimer();
    connect(mTimer,&QTimer::timeout,this,[=](){
        if(mTimerFunc)mTimerFunc();
    });

    mStartMain = make_unique<MainLooper>([=]{
        start(mMils);
    });

    mEndMain = make_unique<MainLooper>([=]{
        cancel();
    });
}

void TTimer::setSingleShot(bool asingleShot){
    mTimer->setSingleShot(asingleShot);
}

void TTimer::start(int mils){
    mTimer->stop();
    mTimer->start(mils);
}

void TTimer::cancel(){
    mTimer->stop();
}

void TTimer::startOnMainLooper(int mils){
    mMils = mils;
    mStartMain.get()->addTask();
}

void TTimer::cancelOnMainLooper(){
    mEndMain.get()->addTask();
}
