#ifndef TTIMER_H
#define TTIMER_H
#include <QTimer>
using namespace std;
#include <memory>
#include "utils/mainlooper.h"
class TTimer:QObject
{
private:
    int mMils;
    std::mutex mMutex;
    QTimer* mTimer;
    std::function<void ()> mTimerFunc = nullptr;
    unique_ptr<MainLooper> mStartMain = nullptr;
    unique_ptr<MainLooper> mEndMain = nullptr;
public:
    explicit TTimer(std::function<void ()> func=[]{});
    void start(int mils);
    void cancel();
    void startOnMainLooper(int mils);
    void cancelOnMainLooper();
    void listener(function<void ()> func){
        this->mTimerFunc = func;
    }
    void setSingleShot(bool asingleShot);

    ~TTimer(){
        if(mTimer){
            mTimer->stop();
            mTimer->setParent(nullptr);
            mTimer->deleteLater();
            mTimerFunc = nullptr;
//            printf("~TTimer \n");
        }
    }
};

#endif // TTIMER_H
