#include "pixmaputils.h"
#include "QPixmap"
#include "../libs/extra/qrencode.h"

PixmapUtils::PixmapUtils()
{

}

QPixmap PixmapUtils::createQRCode(const QString &text,int size){
    int margin = 2;
     if (text.length() == 0)
     {
      return QPixmap();
     }
     QRcode *qrcode = QRcode_encodeString(text.toLocal8Bit(), 3, QR_ECLEVEL_H, QR_MODE_8, 1);
     if (qrcode == NULL) {
      return QPixmap();
     }
     unsigned char *p, *q;
     p = NULL;
     q = NULL;
     int x, y, bit;
     int realwidth;

     realwidth = qrcode->width;
     QImage image = QImage(realwidth, realwidth, QImage::Format_Indexed8);
     QRgb value;
     value = qRgb(255, 255, 255);
     image.setColor(0, value);
     value = qRgb(0, 0, 0);
     image.setColor(1, value);
     image.setColor(2, value);
     image.fill(0);
     p = qrcode->data;
     for (y = 0; y<qrcode->width; y++) {
      bit = 7;
      q += margin / 8;
      bit = 7 - (margin % 8);
      for (x = 0; x<qrcode->width; x++) {
       if ((*p & 1) << bit)
        image.setPixel(x, y, 1);
       else
        image.setPixel(x, y, 0);
       bit--;
       if (bit < 0)
       {
        q++;
        bit = 7;
       }
       p++;
      }
     }
     return QPixmap::fromImage(image.scaledToWidth(size));
}
