#ifndef QRLOGINWINDOW_H
#define QRLOGINWINDOW_H
#include "QVBoxLayout"
#include "QHBoxLayout"
#include <QWidget>
#include <QTimeLine>
#include "widgets/toastwidget.h"
#include "widgets/progressdialog.h"
#include "presenters/qrloginpresenter.h"

class QLabel;
class MainWindow;
class QrLabel;
class EnterpriseAccInfo;
class QrLoginWindow : public QWidget
{
    Q_OBJECT
private:
    QSize mSize;
    ToastWidget * _toast;
     ProgressDialog* _progdialog;
    QrLabel* mQrLabel;
    int mQrImageX = -1;
    QTimeLine* mAnimTimeLine;
    int _windowBlurRadius;
    const int mPaddingTop = 50;
    QLabel* mQrNavLabel;
    bool mMouseIsEnter = false;
    int mQrWidth;
    MainWindow* mHost;
    std::unique_ptr<QrLoginPresenter> mPresenterPtr = nullptr;
    QWidget* getBackButton();
    QHBoxLayout* layQrLay();
    void goSelectAccWindow(const string& uid,const string& token);
public:
    QrLoginWindow(QWidget *parent = nullptr,QSize size = QSize());

    static QSize getWindowSize(){
        return QSize(421,298);
    }
    QHBoxLayout * getDecLay();
    void loadQrData();
    void setMainWindow(MainWindow*);

signals:

};

#endif // QRLOGINWINDOW_H
