#ifndef SETTINGPAGE_H
#define SETTINGPAGE_H

#include <QWidget>
#include <QLineEdit>
#include "widgets/toastwidget.h"
#include "QPushButton"
class SettingPage : public QWidget
{
    Q_OBJECT
private:
    QLineEdit * mEdit;
    const int mWidth = 390;
    bool mWindowRadiusAble = true;
    QFont mFont;
    int mLabelHeight;
    QList<int> _times = {15,30,60,120};
    QList<QString> _timesNames = {"15分钟","30分钟","1小时","2小时"};
    int mSelectTimeIndex = 2;
    int mDrawStartY = 30;
    QPushButton * mSelect;
    ToastWidget* mToast;
    void showTimeMsgWin(int width,int showX,int showY);
public:
    explicit SettingPage(QWidget *parent = nullptr);
    void closeEvent(QCloseEvent *event) override;
    void paintEvent(QPaintEvent *event) override;

    void show(int x,int y);
signals:
    void closed();
};

#endif // SETTINGPAGE_H
