#ifndef SINGLEMEMORY_H
#define SINGLEMEMORY_H
#include <QObject>
#include<QSharedMemory>

class SingleMemory
{

private:
    std::function<void (bool)> mCreatorListener = nullptr;
    std::string mName;
    QSharedMemory *mShareMem = nullptr;
    int mMemeryLen;
    std::string name;
public:
    enum AccessMode
    {
        ReadOnly,
        ReadWrite
    };

    SingleMemory(int memeryLen,std::string name){
        this->mMemeryLen = memeryLen;
        this->name = name;
    }

    void setListener(const std::function<void (bool)>& creatorListener){
        this->mCreatorListener = creatorListener;
        mShareMem = new QSharedMemory(QString(name.c_str()));
        volatile short i = 2;
        while (i--){
            if (mShareMem->attach(QSharedMemory::ReadWrite)){
                mShareMem->detach();
            }
        }
        if(mCreatorListener)mCreatorListener(mShareMem->create(mMemeryLen));
    }

    void* data(){
        return mShareMem->data();
    }

    bool isAttached(){
        return mShareMem->isAttached();
    }

    bool attach(AccessMode mode){
        return mShareMem->attach(mode==ReadOnly?QSharedMemory::ReadOnly:QSharedMemory::ReadWrite);
    }

    void detach(){
        mShareMem->detach();
    }

    void lock(){
        mShareMem->lock();
    }

    void unlock(){
        mShareMem->unlock();
    }

    ~SingleMemory(){
        delete mShareMem;
    }
};

#endif // SINGLEMEMORY_H
