#ifndef STRINGUTILS_H
#define STRINGUTILS_H
#include "QObject"
#include <string>
#include <QMessageAuthenticationCode>
using namespace std;
class StringUtils
{
public:
    StringUtils();
    static QString getUUid();
    static string hash256(const char* data,const string& key){
        QByteArray sign = QMessageAuthenticationCode::hash(data, key.c_str(), QCryptographicHash::Sha256).toBase64();
        return string(sign.data());
    }
    static QString md5(const QString&);
    static QString aesCBCPKCS5PADDINGEncode(const QString& pcInput,const QString& key, const QString& iv);
    static QByteArray aesCBCPKCS5PADDINGDecode(const QString& pcInput,const QString& key, const QString& iv);
    static QByteArray aesCBCPKCS5PADDINGEncode2Byte(const QString& pcInput,const QString& key, const QString& iv);

    static std::string base64(unsigned char* encrypt_data,int size);
    static QString base64QString(const QString& encrypt_data);
    static inline bool is_base64(const char c);
    static std::string base64_decode(std::string const & encoded_string);
    static QString gbk2Utf8String(char* src,size_t inlen);
    static bool gbk2utf8(char* src, char* dest, size_t inlen);
    static ushort unicodeChar(char c);
    static string encodeBase64(const string& data){
        if(data.length() == 0)return "";
        return (QString(data.c_str()).toUtf8().toBase64()).toStdString();
    }

    static vector<char> decodeBase64(const char* data){
        QByteArray byt = QByteArray::fromBase64(QByteArray(data));
        int len = byt.length();
        vector<char> bytes(len);
        memcpy(bytes.data(),byt.data(),len);
        return bytes;
    }
private:

};

#endif // STRINGUTILS_H
