#ifndef QMLINEEDIT_CPP
#define QMLINEEDIT_CPP
#include "QMLineEdit.h"
using namespace ::std;

QMLineEdit::QMLineEdit(QWidget *parent):QLineEdit(parent){
    installEventFilter(this);
}

void QMLineEdit::changeEvent(QEvent * e) {
    if(e->type() == QEvent::LanguageChange && _trKey.length() > 0){
         setPlaceholderTextFromTr(QObject::tr(_trKey.c_str()),_trKey);
    }
}

void QMLineEdit::setPlaceholderTextFromTr(QString text,const string& trKey){
    this->_trKey = (string)trKey;
    setPlaceholderText(text);
}

bool QMLineEdit::eventFilter(QObject *target, QEvent *event) {
    if(target == this) {
        if(event->type() == QEvent::KeyPress) {
            QKeyEvent *k = static_cast<QKeyEvent *>(event);
            emit onKeyDown(k->key());
        }
    }
    return QWidget::eventFilter(target,event);
}

#endif
