#ifndef ADJUSTLENGTHPUSHBUTTON_H
#define ADJUSTLENGTHPUSHBUTTON_H
#include "widgets/clickedlabel.h"
#include "QLabel"

class AdjustLengthPushButtonTip : public QLabel{
    void paintEvent(QPaintEvent *) override;
};

class AdjustLengthPushButton : public ClickedLabel
{
    Q_OBJECT
private:
    bool mNeedShowNav = false;
    int mPaddingLeft = 0 , mPaddingRight = 0;

    QString mUserText;
    QString target;
    QLabel* mWarningDialog;
    int mMoveX,mMoveY;
    int mTextWidth;
    const int FONT_SIZE = 13;
    AdjustLengthPushButtonTip * mNavLabel = nullptr;
public:
    void setPadding(int left,int right){
        this->mPaddingLeft = left;
        this->mPaddingRight = right;
    }
    explicit AdjustLengthPushButton(QWidget* p = nullptr);
    void resizeEvent(QResizeEvent *event) override;
    void setText(const QString &text,bool fromUser = true);
    void mouseMoveEvent(QMouseEvent *event) override;
    void enterEvent(QEvent *event) override;
    void leaveEvent(QEvent *event) override;
    void paintEvent(QPaintEvent *) override;
    QString userText();

    ~AdjustLengthPushButton(){
        if(mNavLabel){
            delete mNavLabel;
        }
    }
};

#endif // ADJUSTLENGTHPUSHBUTTON_H
