#ifndef DRAGMOVEDWIDGET_H
#define DRAGMOVEDWIDGET_H
#include "event/dragevent.h"

#include <QWidget>

class DragMovedWidget : public QWidget
{
    Q_OBJECT
private:
    QWidget * mHost = nullptr;
    bool _canMoveWindow = false;
    QPoint mMovedPosition;
    QPoint mDownLocalPosition;
    DragEvent* mDragEvent;
public:

    explicit DragMovedWidget(QWidget *parent = nullptr);
    void mouseMoveEvent(QMouseEvent *event) override;
    void mousePressEvent(QMouseEvent *event) override;
    void mouseReleaseEvent(QMouseEvent *event) override;
    void leaveEvent(QEvent *event) override;

    void mouseDoubleClickEvent(QMouseEvent *event) override;
    void setHost(QWidget*);
    void setDragEvent(DragEvent* mouseEventListener);
signals:

};

#endif // DRAGMOVEDWIDGET_H
