#ifndef PROGRESSDIALOG_H
#define PROGRESSDIALOG_H

#include <QWidget>
#include "QTimeLine"

class ProgressDialog : public QWidget
{
    Q_OBJECT

private:
//    QString _msg;
    bool _isDismissed = false;
    QTimeLine * _lineAnim = nullptr;
    QTimeLine * _progAnim = nullptr;
    QColor _bgColor = QColor(0,0,0,0);
    int _dialog_width = 100;
    int _progress = 0;
    long _showTime = 0;
    int _radius = 0;
    QString _text = "loading";
    const int _dialog_height = 101;
    const int _dialog_prog_width = 30;
    bool _showedMsg = false;
public:

    explicit ProgressDialog(QWidget *parent = nullptr);
    void setLabel(const QString& text);
    void setRadius(int radius);
    void showDialog(const QString& string);
    void dismiss();
    void windowMode(){
        setWindowFlags(Qt::Window |Qt::FramelessWindowHint);
    }

    void raise(){
        QWidget::raise();
    }

    void activateWindow(){
        QWidget::activateWindow();
    }

    void move(int x,int y){
        QWidget::move(x,y);
    }

    void paintEvent(QPaintEvent *event) override;
    QSize getDialogSize(){
        return QSize(_dialog_width,_dialog_height);
    }
};

#endif // PROGRESSDIALOG_H
