#ifndef QRLABEL_H
#define QRLABEL_H

#include <QWidget>

class QrLabel : public QWidget
{
    Q_OBJECT
private:
    QFont mFont;
    int mImageX = 0;
    bool mIsProgressMode = false;
    QString mProgressText = "";
    QPixmap mQrImage;
    bool mScanSuc = false;
    QPixmap mSucPix;
    int mSucTxtHeight;
    QString mScanSucTxt = "扫码成功";
public:
    explicit QrLabel(QWidget *parent = nullptr);
    void paintEvent(QPaintEvent *event) override;
    void setImage(QPixmap& pixmap);
    void moveImage(int x);
    void mousePressEvent(QMouseEvent *event) override{};
    int getImageX();
    void mouseReleaseEvent(QMouseEvent *event) override;
    void setProgress(bool progressMode,const QString& progText);
    void scanSuccess();

signals:
    void qrImageClicked();
};

#endif // QRLABEL_H
