#ifndef TOASTWIDGET_H
#define TOASTWIDGET_H
#include "QWidget"
#include <iostream>
using namespace std;
class ToastWidget: public QWidget
{
    Q_OBJECT
private:
     int  g_duration = 1;
    QString _text = "";
    QVector<QString> lines;
    int _bgalpha = 0;
    bool _isShowing = false;
    QString _measuredText = nullptr;
    QSize _size;
    bool _autoDelete = false;
    int _fontSize = 13;
    vector<QString> _texts;
    const int _paddingLR = 7;
    int _txtHeight = 0;
    bool _mustMeasureSize = true;
    const int _paddingTB = 10;
    void measureTextLines(int width);
    void showMesssagePool(const QString& text);
    void showMesssagePoolEnd();
public:
    void setFontSize(int fontSize){
        this->_fontSize = fontSize;
    }
    void measureText(const QString& text);
    ToastWidget(QWidget* parent = nullptr);
    void showMesssage(const QString& text);
    void paintEvent(QPaintEvent *event) override;
    ~ToastWidget();
    void setAutoDelete(bool f){
        this->_autoDelete = f;
    }

signals:
    void measure(int width,int height);
};

#endif // TOASTWIDGET_H
