#ifndef WINDOWNMINBTN_H
#define WINDOWNMINBTN_H
#include <QWidget>
#include <QPainter>
#include <QColor>
#include <cmath>
#include <QApplication>
#include <iostream>
#include <QDebug>
#include <QTimer>

class WindowMinButton :public QWidget{
private:
    bool isFocued;
    QWidget* m_host;
public:
    WindowMinButton(){
        isFocued = false;
    }

    void paintEvent(QPaintEvent *) override{
        QPainter painter(this);
        painter.fillRect(rect(),Qt::transparent);
        painter.setRenderHint(QPainter::Antialiasing);
        int w = width();
        int h = height();
        QPen pen;

        QColor containColor = QColor(0,0,0, isFocued ? 55 : 40);
        painter.setPen(Qt::NoPen);
        painter.setBrush(containColor);
        painter.drawEllipse(0,0,w,h);

        pen.setWidth(2);
        pen.setColor(Qt::white);
        painter.setPen(pen);
        painter.setBrush(Qt::NoBrush);
        painter.drawLine(5 ,h / 2, w - 5 , h / 2);
    }

    void enterEvent(QEvent *) override{
        isFocued = true;
        repaint();
    }

    void setHost(QWidget* host){
        this->m_host = host;
    }

    void leaveEvent(QEvent *) override{
        isFocued = false;
        repaint();
    }

    void mouseReleaseEvent(QMouseEvent *) override{
        if(isFocued){
            #ifdef Q_OS_MAC
            m_host->setWindowFlag(Qt::FramelessWindowHint,false);
            m_host->showMinimized();
            m_host->setWindowFlag(Qt::FramelessWindowHint,true);
            #endif
            m_host->showMinimized();
        }
    }

    void mousePressEvent(QMouseEvent *) override{
    }

    void mouseMoveEvent(QMouseEvent *) override{}
};
#endif
