#include "windowmorebtn.h"
#include "QPainter"

WindowMoreBtn::WindowMoreBtn(QWidget* parent):QWidget(parent)
{

}

void WindowMoreBtn::paintEvent(QPaintEvent *event){
    QPainter painter(this);
    painter.fillRect(rect(),Qt::transparent);
    painter.setRenderHint(QPainter::Antialiasing);
    int w = width();
    int h = height();
    QPen pen;

    QColor containColor = QColor(0,0,0, isFocued ? 55 : 40);
    painter.setPen(Qt::NoPen);
    painter.setBrush(containColor);
    painter.drawEllipse(0,0,w,h);

    painter.setPen(Qt::NoPen);
    painter.setBrush(Qt::white);

    int lrPadding = w * 0.1;
    int margin = w * 0.1;
    int size = (w - lrPadding*2 - margin*2) / 3;
    int startY = (h - size) / 2;

    for(int i=0;i<3;i++)
        painter.drawEllipse(lrPadding + (margin+size)*i,startY,size,size);
}

void WindowMoreBtn::mousePressEvent(QMouseEvent *) {

}

void WindowMoreBtn::mouseMoveEvent(QMouseEvent *) {

}

void WindowMoreBtn::mouseReleaseEvent(QMouseEvent *) {

}

void WindowMoreBtn::enterEvent(QEvent *) {
    isFocued = true;
    repaint();
}

void WindowMoreBtn::leaveEvent(QEvent *) {
    isFocued = false;
    repaint();
}

