#include "windowresizebtn.h"
#include "QPainter"
#include "QPen"

WindowResizeBtn::WindowResizeBtn(QWidget* parent):QWidget(parent)
{

}

void WindowResizeBtn::mousePressEvent(QMouseEvent *) {}
void WindowResizeBtn::mouseMoveEvent(QMouseEvent *) {}

void WindowResizeBtn::mouseReleaseEvent(QMouseEvent *) {
    if(isFocued && m_host){
        if(m_host->isMaximized()){
            m_host->showNormal();
        }else{
            m_host->showMaximized();
        }
    }
}

void WindowResizeBtn::enterEvent(QEvent *) {
    isFocued = true;
    repaint();
}

void WindowResizeBtn::leaveEvent(QEvent *) {
    isFocued = false;
    repaint();
}


void WindowResizeBtn::paintEvent(QPaintEvent *){
    QPainter painter(this);
    painter.fillRect(rect(),Qt::transparent);
    painter.setRenderHint(QPainter::Antialiasing);
    int w = width();
    int h = height();

    QColor containColor = QColor(0,0,0, isFocued ? 55 : 40);
    painter.setPen(Qt::NoPen);
    painter.setBrush(containColor);
    painter.drawEllipse(0,0,w,h);

    QPen pen;
    pen.setWidth(2);
    painter.setPen(pen);
    if(m_host && m_host->isMaximized()){
        painter.setBrush(Qt::NoBrush);
        float perc = 0.37;
        int size = w * perc;
        int start = (1.0 - perc) / 2.0 * w;
        int off = 0.1 * w;

        QRect rect(start - off+1.5,start+ off+1,size,size);

        pen.setColor(Qt::white);
        painter.setPen(pen);

        painter.drawRoundedRect(start + off+0.5,start- off+1,size,size,1,1);

        pen.setColor(Qt::white);
        painter.setPen(pen);
        painter.drawRoundedRect(rect,1,1);
    }else{
        pen.setColor(Qt::white);
        painter.setPen(pen);
        painter.setBrush(Qt::NoBrush);

        int size = w * 0.43;
        int start = 0.285*w+.5;
        painter.drawRect(start,start,size,size);
    }
}

void WindowResizeBtn::refreMode(){
    update();
}

void WindowResizeBtn::setHost(QWidget* host){
    this->m_host = host;
}
