#ifndef WIDGETUTILS_H
#define WIDGETUTILS_H
#include "QFontMetrics"
#include "QFont"
#include <QGuiApplication>
#include <QScreen>
#include "pojo/size.h"
#include <QLineEdit>
#include "widgets/toastwidget.h"

class WidgetUtils
{
public:
    WidgetUtils();
    static inline QRect getTextRect(QFont& font,const QString& str){
        QFontMetrics fm(font);
        return fm.boundingRect(str);
    }

    static inline int getTextWidth(QFont& font,const QString& str){
        QFontMetrics fm(font);

#if (QT_VERSION <= QT_VERSION_CHECK(5,14,0))
        return fm.width(str);
#else
        return fm.horizontalAdvance(str);
#endif
    }

    static Size availableSize(){
        QSize size = QGuiApplication::screens()[0]->availableSize();
        return Size(size.width(),size.height());
    }

    static void getCommonFocusLineEditEdit(QWidget* widght){
//        FocusLineEdit mEdit = new FocusLineEdit(widght);
//        mEdit->setWindowModality(Qt::NonModal);
//        mEdit->clearFocus();

//        mEdit->setKeyEventListener(widght);
//        mEdit->setFixedSize(1,1);
//        connect(mEdit,&QLineEdit::textChanged,widght,[=](QString& text){

////            this->_manager->textChanged(text.toStdString());
//            mEdit->setText("");
//        });
    }

    static void toastWindowAndRaise(const string& msg){
        ToastWidget* toast = new ToastWidget();
        toast->setAttribute(Qt::WA_TranslucentBackground);
        toast->setAutoDelete(true);
        toast->setFontSize(14);
        toast->measureText(QString(msg.c_str()));
        QSize size = QGuiApplication::screens()[0]->availableSize();
        toast->move((size.width() - toast->width())/2,(size.height() - toast->height())/2);
        toast->showMesssage(QString(msg.c_str()));
        toast->raise();
    }
};

#endif // WIDGETUTILS_H
